﻿namespace AgaveRobotics.Web.Demos.Controller
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Net;
    using System.Web.Http;
    using System.Net.Http;
    using AgaveRobotics.Web.Demos.Model;

    public class MessagesController : ApiController
    {
        static readonly IMessageRepository repository = new MessageRepository();

        public IEnumerable<Message> GetAllMessages()
        {
            return repository.GetAll();
        }

        public Message GetMessage(int id)
        {
            Message item = repository.Get(id);
            if (item == null)
            {
                throw new HttpResponseException(HttpStatusCode.NotFound);
            }
            return item;
        }

        public HttpResponseMessage PostMessage(Message item)
        {
            item = repository.Add(item);
            var response = Request.CreateResponse<Message>(HttpStatusCode.Created, item);

            string uri = Url.Link("Default API", new { id = item.Id });
            response.Headers.Location = new Uri(uri);
            return response;
        }

        public void DeleteMessage(int id)
        {
            Message item = repository.Get(id);
            if (item == null)
            {
                throw new HttpResponseException(HttpStatusCode.NotFound);
            }
            repository.Remove(id);
        }
    }
}
