﻿namespace AgaveRobotics.Web.Demos.Controller
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Net;
    using System.Web.Http;
    using System.Net.Http;
    using AgaveRobotics.Web.Demos.Model;

    public class SubscribersController : ApiController
    {
        static readonly ISubscriberRepository repository = new SubscriberRepository();


        public IEnumerable<Subscriber> GetAllSubscribers()
        {
            return repository.GetAll();
        }

        public Subscriber GetSubscriber(int id)
        {
            Subscriber item = repository.Get(id);
            if (item == null)
            {
                throw new HttpResponseException(HttpStatusCode.NotFound);
            }
            return item;
        }

        public HttpResponseMessage PostSubscriber(Subscriber item)
        {
            item = repository.Add(item);
            var response = Request.CreateResponse<Subscriber>(HttpStatusCode.Created, item);

            string uri = Url.Link("Default API", new { id = item.Id });
            response.Headers.Location = new Uri(uri);
            return response;
        }

        public void DeleteSubscriber(int id)
        {
            Subscriber item = repository.Get(id);
            if (item == null)
            {
                throw new HttpResponseException(HttpStatusCode.NotFound);
            }
            repository.Remove(id);
        }

    }
}
