﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Http;
using AgaveRobotics.Web.Demos.Model;

namespace SubsciptionTester
{
    class SubScriptionTest
    {
        static HttpClient client = new HttpClient();

        static void Main(string[] args)
        {
            bool run = true;
            string userparam = string.Empty;

            client.BaseAddress = new Uri("http://localhost:8080");
            AddSubscriber(new Subscriber { Ip = "192.168.1.104", Port = 13000, Username = "W5200" });
            AddSubscriber(new Subscriber { Ip = "192.168.1.104", Port = 13001, Username = "spinneret" });
            AddSubscriber(new Subscriber { Ip = "192.168.1.104", Port = 13000, Username = "W5200" });
            ListAllSubscribers();

            //AddMessage(new Message { From = "spinneret", To = "W5200", Content = "Hi W5200 from Spinneret." });
            //AddMessage(new Message { From = "W5200", To = "spinneret", Content = "Hi spinneret from W5200." });
            //ListAllMessages();

            
            while(true)
            {
                Console.WriteLine("Press Q to quit.  Press any key to send a default message.");
                userparam = Console.ReadLine();
                if (userparam.ToUpper() == "Q")
                    break;
                else
                    AddMessage(new Message { From = "spinneret", To = "W5200", Content = "Hi W5200 from Spinneret." });
            }

        }


        static void SendMessage(Message item)
        {
            try
            {
                HttpResponseMessage resp = client.PostAsXmlAsync("api/Messages", item).Result;
                resp.EnsureSuccessStatusCode();
                //Console.WriteLine("Status: {0}\n\nVersion: {1}\n\nContent: {2}\n\nLocation: {3}\n\n", resp.StatusCode, resp.Version, resp.Content, resp.Headers.Location);
                Console.WriteLine("Status: {0}\nLocation: {1}", resp.StatusCode, resp.Headers.Location);
            }
            catch (HttpRequestException e)
            {
                Console.WriteLine(e.Message);
            }
        }

        static void ListAllMessages()
        {
            HttpResponseMessage resp = client.GetAsync("api/Messages").Result;
            resp.EnsureSuccessStatusCode();

            var messages = resp.Content.ReadAsAsync<IEnumerable<Message>>().Result;
            Console.WriteLine("Message List");
            foreach (var m in messages)
            {
                Console.WriteLine("{0} {1} {2} ({3})", m.Id, m.From, m.To, m.Content);
            }

            if (messages.Count() == 0)
                Console.WriteLine("Message buffer is empty");
        }

        static void AddMessage(Message item)
        {
            try
            {
                HttpResponseMessage resp = client.PostAsXmlAsync("api/Messages", item).Result;
                resp.EnsureSuccessStatusCode();
                //Console.WriteLine("Status: {0}\n\nVersion: {1}\n\nContent: {2}\n\nLocation: {3}\n\n", resp.StatusCode, resp.Version, resp.Content, resp.Headers.Location);
                Console.WriteLine("Status: {0}\nLocation: {1}", resp.StatusCode, resp.Headers.Location);
            }
            catch (HttpRequestException e)
            {
                Console.WriteLine(e.Message);
            }  
        }
        
        static void ListAllSubscribers()
        {
            HttpResponseMessage resp = client.GetAsync("api/Subscribers").Result;
            resp.EnsureSuccessStatusCode();

            var subscribers = resp.Content.ReadAsAsync<IEnumerable<Subscriber>>().Result;
            Console.WriteLine("Subscriber List");
            foreach (var s in subscribers)
            {
                Console.WriteLine("{0} {1} {2} ({3})", s.Id, s.Username, s.Ip, s.Port);
            }
        }

        static void AddSubscriber(Subscriber item)
        {
            try
            {
                HttpResponseMessage resp = client.PostAsXmlAsync("api/Subscribers", item).Result;
                resp.EnsureSuccessStatusCode();
                //Console.WriteLine("Status: {0}\n\nVersion: {1}\n\nContent: {2}\n\nLocation: {3}\n\n", resp.StatusCode, resp.Version, resp.Content, resp.Headers.Location);
                Console.WriteLine("Status: {0}\nLocation: {1}", resp.StatusCode, resp.Headers.Location);
            }
            catch (HttpRequestException e)
            {
                Console.WriteLine(e.Message);
            }
        }


    }//Program
}//SubsciptionTester
